Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshStripifier.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshStripifier.cpp	(revision 2341)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshStripifier.cpp	(revision 2549)
@@ -19,517 +19,264 @@
 //-------------------------------------------------------------------------
 
-//-------------------------------------------------------------------------
-//	InitList.
-//-------------------------------------------------------------------------
-BOOL CustomStripifier::InitList(PLISTHEAD LHead)
-{
-	if (LHead == NULL)
-	{
-		return	FALSE;
-	}
-
-	LHead->LHeaders[LISTHEAD] = LHead->LHeaders[LISTTAIL] = NULL;
-	LHead->NumList = 0;
-
-	return	TRUE;
-}
-
-//-------------------------------------------------------------------------
-//	AddHead.
-//-------------------------------------------------------------------------
-BOOL CustomStripifier::AddHead(PLISTHEAD LHead, PLISTINFO LInfo)
-{
-	if (LHead == NULL || LInfo == NULL)
-	{
-		return(FALSE);
-	}
-
-	if (EMPTYLIST(LHead))
-	{
-		LHead->LHeaders[LISTTAIL] = LInfo;
-	}
-	else
-	{
-		LHead->LHeaders[LISTHEAD]->ListNode.Previous = (void  *) LInfo;
-	}
-
-	LInfo->ListNode.Next			=	(void  *) LHead->LHeaders[LISTHEAD];
-	LHead->LHeaders[LISTHEAD]	=	LInfo;
-	LInfo->ListNode.Previous	=	NULL;
-	LHead->NumList++;
-
-	return(TRUE);
-}
-
-///	AddTail
-BOOL  CustomStripifier::AddTail(PLISTHEAD LHead, PLISTINFO LInfo)
-{
-	if (LHead == NULL || LInfo == NULL)
-	{
-		return	FALSE;
-	}
-
-	if (EMPTYLIST(LHead))
-	{
-		LHead->LHeaders[LISTHEAD] = LInfo;
-	}
-	else
-	{
-		LHead->LHeaders[LISTTAIL]->ListNode.Next = (void *) LInfo;
-	}
-
-	LInfo->ListNode.Previous	= (void  *) LHead->LHeaders[LISTTAIL];
-	LHead->LHeaders[LISTTAIL] = LInfo;
-	LInfo->ListNode.Next			= NULL;
-	LHead->NumList++;
-
-	return	TRUE;
-}
-
-///	InsertNode
-BOOL  CustomStripifier::InsertNode( PLISTHEAD LHead, int nPos, PLISTINFO LInfo )
-{
-	PLISTINFO add_node;
-
-  if ( LHead == NULL || LInfo == NULL || nPos > NumOnList( LHead ) )
-	{
-		return	FALSE;
-	}
-
-	if ( nPos == 0 )
-	{
-		AddHead( LHead, LInfo );
-	}
-	else if ( nPos == NumOnList( LHead ) )
-	{
-		AddTail( LHead, LInfo );
-	}
-	else
-	{
-		if ( (add_node = PeekList( LHead, LISTHEAD, nPos - 1 )) == NULL )
+
+///	stripify:	Make triangle strips for a given mesh.
+int CustomStripifier::stripify (Geometry::Mesh	*geoMesh)
+{
+	int			oddStrip;
+	int				i;
+	unsigned int	j;
+	int				num_vert	=	0;
+	int				num_faces	=	0;
+	int				num_tris    = 0;
+	int				totalStripIndices;
+
+	Geometry::SubMesh*	geoSubMesh;
+	vector_int v_indices;
+ 
+	//	Process OK.
+	mError = 0;
+
+	StripFaceAdj = NULL;
+
+	//	Progress bar.
+	float	percent;
+	percent	=	float(100.0 / (geoMesh->mSubMeshCount * 10.0));
+
+	//	For all submeshes.
+	for(unsigned int k = 0; k < geoMesh->mSubMeshCount; k++)
+	{
+		//	Leaves submesh doesn't stripify.
+		if (mSubMeshLeaves != k)
 		{
-			return	FALSE;
+			//Free structures
+			v_indices.clear();
+			StripFaces.clear();
+			my_vector.clear();
+			my_vector.push_back(v_indices);
+
+			if (StripFaceAdj != NULL)
+				free(StripFaceAdj);
+
+			StripFaceAdj = NULL;
+
+			for (int i=0;i<StripEdges.size();i++)
+				StripEdges[i].clear();
+
+			StripEdges.clear();
+
+			if (StripArray != NULL)
+			{
+				for (int i=0;i<60;i++)
+					StripArray[i].clear();
+
+			}
+
+			for (int i=0;i<StripVertices.size();i++)
+				StripVertices[i].clear();
+
+			StripVertices.clear();
+
+			//Let's start striping
+			num_tiras	=	0;
+
+			//	Actual submesh.
+			geoSubMesh	=	&geoMesh->mSubMesh[k];
+
+			//	Mesh type.
+			geoSubMesh->mType	=	GEO_TRIANGLE_STRIPS;
+
+			num_vert	=	int(geoSubMesh->mVertexBuffer->mVertexCount);
+			num_faces	=	int(geoSubMesh->mIndexCount / 3);
+			num_tris	=	num_faces;
+
+			//	Updtate progress bar.
+			if (mUPB)
+			{
+				mUPB(percent*2);
+			}
+
+			//	Load the object into memory.
+			ReadData(geoSubMesh, num_faces, num_vert);
+
+			//	Updtate progress bar.
+			if (mUPB)
+			{
+				mUPB(percent);
+			}
+
+			FindAdjacencies(num_faces,num_vert);
+
+			//	Updtate progress bar.
+			if (mUPB)
+			{
+				mUPB(percent);
+			}
+
+			//	If the mesh is not manifold.
+			if (mError)
+			{
+				return	0;
+			}
+
+			StoreAdjacencies(num_faces);
+
+			//	Updtate progress bar.
+			if (mUPB)
+			{
+				mUPB(percent);
+			}
+
+			Stripification();
+
+			//	Updtate progress bar.
+			if (mUPB)
+			{
+				mUPB(percent);
+			}
+
+			//	Updtate progress bar.
+			if (mUPB)
+			{
+				mUPB(percent);
+			}
+
+			num_vert	=	num_tiras;
+
+			totalStripIndices	=	0;
+
+			geoSubMesh->mStripCount	=	num_tiras;
+
+			//	Memory for the array of strips beginnigs
+			geoSubMesh->mStrip = (Index**) malloc(sizeof(Index*) * geoSubMesh->mStripCount);
+
+			// The first one will be different
+			v_indices	=	my_vector[1];
+
+			//	Number of vertices of a strip odd or even.
+			if(v_indices.size() % 2)
+			{
+				oddStrip	= true;
+			}
+			else
+			{
+				oddStrip	=	false;
+			}
+
+			//	Obtiene el total de indices de la primera strip.
+			geoSubMesh->mIndexCount	=	v_indices.size();
+
+			//	Calculate the Index Count.
+			for (i = 2; i <= num_tiras; i++)
+			{
+				v_indices								=		my_vector[i];
+				geoSubMesh->mIndexCount	+=	v_indices.size() + 2;
+
+				//	Insert a new vertex if the strip es odd.
+				if(oddStrip)
+				{
+					geoSubMesh->mIndexCount++;
+				}
+
+				//	Number of vertices of a strip odd or even.
+				if(v_indices.size() % 2)
+					oddStrip	= true;
+				else
+					oddStrip	=	false;
+			}
+
+			//	Delete the actual indices.
+			delete[]	geoSubMesh->mIndex;
+			geoSubMesh->mIndex	=	new	Index[geoSubMesh->mIndexCount];
+			//--------------------------------------------
+
+			// First time will be different
+			v_indices =	my_vector[1];
+
+			//	Copy first strip in the index array
+			for(j = 0;j < v_indices.size();j++)
+			{
+				geoSubMesh->mIndex[totalStripIndices++]	=	v_indices[j];
+			}
+
+			//Assign beginning of first strip
+			geoSubMesh->mStrip[0]	=	&geoSubMesh->mIndex[0];
+
+			//	Updtate progress bar.
+			if (mUPB)
+			{
+				mUPB(percent);
+			}
+
+			//	Number of vertices of a strip odd or even.
+			if(v_indices.size() % 2)
+			{
+				oddStrip	= true;
+			}
+			else
+			{
+				oddStrip	=	false;
+			}
+
+			//For all the strips but the first one
+			for(i	=	2;	i <= num_tiras;	i++)
+			{
+				//	initial degenerate triangle (copy last twice)
+				geoSubMesh->mIndex[totalStripIndices++]	=	geoSubMesh->
+					mIndex[totalStripIndices-1];
+
+				v_indices								=	my_vector[i];
+
+				//	initial degenerate triangle (copy first twice)
+				
+				geoSubMesh->mIndex[totalStripIndices++]	=	v_indices[0];
+
+				//	Asigna el inicio de la tira de triangulos.
+				geoSubMesh->mStrip[i-1]	=	&geoSubMesh->mIndex[totalStripIndices - 1];
+
+				//	Degenerate Triangle
+				geoSubMesh->mIndex[totalStripIndices++]	=	v_indices[0];
+
+				//	Insert a new vertex if the strip es odd.
+				if(oddStrip)
+				{
+					geoSubMesh->mIndex[totalStripIndices++]	=	v_indices[0];
+				}
+
+				//	Number of vertices of a strip odd or even.
+				if(v_indices.size() % 2)
+				{
+					oddStrip	= true;
+				}
+				else
+				{
+					oddStrip	=	false;
+				}
+				
+				//	Copy current strip
+				for(j	=	1;	j < v_indices.size();	j++)
+				{
+					geoSubMesh->mIndex[totalStripIndices++]	=	v_indices[j];
+				}
+			}
+
+
 		}
- 
-		((PLISTINFO)add_node->ListNode.Next)->ListNode.Previous = LInfo;
-
-		LInfo->ListNode.Next      = add_node->ListNode.Next;
-		LInfo->ListNode.Previous  = add_node;
-		add_node->ListNode.Next   = LInfo;
-		LHead->NumList++;
-	}
-
-	return	TRUE;
-}
-
-///	RemHead:
-PLISTINFO  CustomStripifier::RemHead(PLISTHEAD LHead)
-{
-	PLISTINFO t, t1;
-
-	if ( LHead == NULL || EMPTYLIST(LHead) )
-	{
-		return	NULL;
-	}
-
-	t													=	LHead->LHeaders[LISTHEAD];
-	LHead->LHeaders[LISTHEAD] = (PLISTINFO) t->ListNode.Next;
-
-	if (LHead->LHeaders[LISTHEAD] != NULL)
-	{
-		t1										= (PLISTINFO) t->ListNode.Next;
-		t1->ListNode.Previous = NULL;
-	}
-	else
-	{
-		LHead->LHeaders[LISTTAIL] = NULL;
-	}
-	
-	LHead->NumList--;
-
-	return	t;
-}
-
-///	RemTail:
-PLISTINFO CustomStripifier::RemTail(PLISTHEAD   LHead)
-{
-	PLISTINFO   t, t1;
-
-	if ( LHead == NULL || EMPTYLIST(LHead) )
-	{
-		return	NULL;
-	}
-
-	t													= LHead->LHeaders[LISTTAIL];
-	LHead->LHeaders[LISTTAIL] = (PLISTINFO) t->ListNode.Previous;
-
-	if (LHead->LHeaders[LISTTAIL] != NULL)
-	{
-		t1 = (PLISTINFO) t->ListNode.Previous;
-		t1->ListNode.Next = NULL;
-	}
-	else
-	{
-		LHead->LHeaders[LISTHEAD] = NULL;
-	}
-
-	LHead->NumList--;
-
-	return	t;
-}
-
-///	PeekList:
-PLISTINFO CustomStripifier::PeekList(PLISTHEAD LHead, int wch, int index )
-{
-	PLISTINFO  t;
-
-	if (LHead == NULL)
-	{
-		return	NULL;
-	}
-
-	if ( (t = LHead->LHeaders[wch]) == NULL )
-	{
-		return	NULL;
-	}
-
-	for (; t != NULL && index > 0; index-- )
-	{
-		t = (wch == LISTHEAD)	?	(PLISTINFO) t->ListNode.Next  
-													:	(PLISTINFO) t->ListNode.Previous;
-	}
-
-	return	t;
-}
-
-///	RemoveList:
-PLISTINFO CustomStripifier::RemoveList(PLISTHEAD LHead, PLISTINFO LInfo )
-{
-	PLISTINFO	t;
-	PLISTINFO	t1;
-
-	t	=	LInfo;
-
-	if (LHead == NULL)
-	{
-		return	NULL;
-	}
-
-	if (LHead->LHeaders[LISTHEAD] == t)
-	{
-		t	=	(PLISTINFO) RemHead(LHead);
-	}
-	else if (LHead->LHeaders[LISTTAIL] == t)
-	{
-		t = (PLISTINFO) RemTail(LHead);
-	}
-	else
-	{
-		t1                    = (PLISTINFO) t->ListNode.Previous;
-		t1->ListNode.Next     = t->ListNode.Next;
-		t1                    = (PLISTINFO) t->ListNode.Next;
-		t1->ListNode.Previous = t->ListNode.Previous;
-		LHead->NumList--;
-	}
-
-	return	t;
-}
-
-///	SearchList:
-///			Try to find a specific node in the queue whose key matches with
-///			searching key. Return the pointer to that node if found, return NULL
-///			otherwise
-///	@param	lpHashTbl       => a far pointer to the hash table.
-///	@param	lpKey           => a far poniter to searching key.
-///	@param	CompareCallBack => comparision function.
-///	@return	a far pointer to the node to be found.
-PLISTINFO CustomStripifier::SearchList(
-                        PLISTHEAD listHead,
-                        PVOID lpSKey,
-                        int (* CompareCallBack) ( PVOID, PVOID ) )
-{
-	PLISTINFO list_info;
-
-	list_info = PeekList( listHead, LISTHEAD, 0);
-
-	while ( list_info != NULL )
-	{
-		if ( CompareCallBack( list_info, lpSKey ) )
-		{
-			break;
-		}
-
-		list_info	=	(PLISTINFO) GetNextNode( list_info );
-	}
-
-	return	list_info;
-}
-
-///	init_vert_norms:
-void CustomStripifier::init_vert_norms(int num_vert)
-{
-  /*   Initialize vertex/normal array to have all zeros to
-       start with.
-  */
-  register int x;
-  
-  for (x = 0; x < num_vert; x++)
-	{
-		*(vert_norms + x) = 0;
-	}
-}
-
-///	init_vert_texture:
-void CustomStripifier::init_vert_texture(int num_vert)
-{
-  /*   Initialize vertex/normal array to have all zeros to
-       start with.
-  */
-  register int x;
-  
-  for (x = 0; x < num_vert; x++)
-	{
-    *(vert_texture + x) = 0;
-	}
-}
-
-///	InitVertexTable:
-BOOL CustomStripifier::InitVertexTable( int size )
-{
-  register int index;
-  
-  /*     Initialize the face table */
-  Vertices	=	(ListHead**) malloc(sizeof(ListHead*) * size );
-  
-  if (Vertices)
-	{
-		for (index	=	0; index < size; index++)
-		{
-			Vertices[index] = NULL;
-		}
-
-		return	TRUE;
-
-	}
-
-	return	FALSE;
-}
-
-///	InitFaceTable:
-BOOL CustomStripifier::InitFaceTable( int size )
-{
-  register int index;
-  
-  /*     Initialize the face table */
-  PolFaces = (ListHead**) malloc(sizeof(ListHead*) * size); 
-  
-  if (PolFaces)
-  {
-  	for (index	=	0; index < size; index++)
-		{
-			PolFaces[index] = NULL;
-		}
-
-		return	TRUE;
-	}
-
-	return	FALSE;
-} 
-
-///	InitEdgeTable:
-BOOL CustomStripifier::InitEdgeTable( int size )
-{
-  register int index;
-  
-  /*     Initialize the edge table */
-  PolEdges	=	(ListHead**) malloc(sizeof(ListHead*) * size );
-
-  if (PolEdges)
-	{
-		for (index=0; index < size; index++)
-		{
-			PolEdges[index]	=	NULL;
-		}
-
-		return	TRUE;
-	}
-
-	return	FALSE;
-}
-
-///	InitStripTable:
-void CustomStripifier::InitStripTable( )
-{
-  
-  PLISTHEAD list_head;
-  
-  /*   Initialize the strip table */
-  list_head = (PLISTHEAD) malloc(sizeof(ListHead));
-
-  if (list_head)
-  {
-    InitList(list_head);
-
-    strips[0] = list_head;
-  }
-  else
-  {
-    printf("Out of memory !\n");
-
-    exit(0);
-  }
-  
-}
-
-///	Init_Table_SGI:
-void CustomStripifier::Init_Table_SGI(int numFaces)
-{
-  PLISTHEAD			list_head;
-  int						max_adj		= 60;
-  register			int	x;
-  
-  /*   This routine will initialize the table that will
-       have the faces sorted by the number of adjacent polygons
-       to it.
-  */
-  
-  for (x=0; x< max_adj; x++)
-  {
-		/*	We are allowing the max number of sides of a polygon
-				to be max_adj.
-    */                      
-    list_head = (PLISTHEAD) malloc(sizeof(ListHead));
-
-    if (list_head)
-		{
-			InitList(list_head);
-
-			array[x]	=	list_head;
-		}
-    else
-		{
-			printf("Out of memory !\n");
-			exit(0);
-		}
-	}
-  
-  if (face_array != NULL) /* It seems this function is called more than */
-	{
-    free(face_array);     /* once so we'll free up the old stuff */
-	}
-  
-  face_array = (P_FACE_ADJACENCIES) malloc (sizeof(FACE_ADJACENCIES) * numFaces);
-
-  if (face_array == NULL)
-	{
-    printf("Out of memory !!\n");
-    exit(0);
-  }
-  
-}
-
-///	BuildVertexTable:
-void CustomStripifier::BuildVertexTable(int size)
-{
-  register int	index;
-  PLISTHEAD			list_head;
-  
-  for (index	=	0; index < size; index++)
-  {
-    list_head	=	(PLISTHEAD) malloc(sizeof(ListHead));
-
-    if (list_head)
-		{
-			InitList(list_head);
-
-			Vertices[index]	=	list_head;
-		}
-    else
-		{
-			return;
-		}
-      
-	}
-}
-
-///	BuildFaceTable:
-void CustomStripifier::BuildFaceTable( int size )
-{
-  register int	index;
-  PLISTHEAD			list_head;
-  
-  for (index	=	0; index < size; index++)
-  {
-    list_head	=	(PLISTHEAD) malloc(sizeof(ListHead));
-
-    if (list_head)
-		{
-			InitList(list_head);
-
-			PolFaces[index]	=	list_head;
-		}
-		else
-		{
-			return;
-		}
-	}
-}
-
-///	BuildEdgeTable:
-void CustomStripifier::BuildEdgeTable( int size )
-{
-  register int	index;
-  PLISTHEAD			list_head;
-  
-  for (index	=	0; index < size; index++)
-  {
-  	list_head	=	(PLISTHEAD) malloc(sizeof(ListHead));
-
-		if (list_head)
-		{
-	  	InitList(list_head);
-
-	  	PolEdges[index]	=	list_head;
-		}
-    else
-		{
-			return;
-		}
-	}
-}
-
-///	Start_Vertex_Struct:
-void CustomStripifier::Start_Vertex_Struct(int numVerts)
-{
-  if (InitVertexTable(numVerts))
-  {
-    BuildVertexTable(numVerts);
-  }
-}
-
-///	Start_Face_Struct:
-void CustomStripifier::Start_Face_Struct(int numFaces)
-{
-  if (InitFaceTable(numFaces))
-  {
-    BuildFaceTable(numFaces);
-  }
-}
-
-///	Start_Edge_Struct:
-void CustomStripifier::Start_Edge_Struct(int numVerts)
-{
-  if (InitEdgeTable(numVerts))
-  {
-    BuildEdgeTable(numVerts);
-  }
-}
-
-///	switch_lower:
-void CustomStripifier::switch_lower (int *x, int *y)
-{
-  register int temp;
-  
-  /*	Put lower value in x */
+	}//	End For. SubMeshes.
+
+	//	Updtate progress bar.
+	if (mUPB)
+	{
+		mUPB(100.0);
+	}
+
+	return	1;
+}
+
+
+///	Getlower:
+void CustomStripifier::GetLower (int *x, int *y)
+{
+  int temp;
+  
   if (*y < *x)
   {
@@ -540,60 +287,8 @@
 }
 
-///	member:
-BOOL CustomStripifier::member(int x , int id1, int id2, int id3)
-{
-  /*  Is x in the triangle specified by id1,id2,id3 */
-  if ((x != id1) && (x != id2) && (x != id3))
-	{
-    return	FALSE;
-	}
-
-  return	TRUE;
-}
-
-///	Exist:
-BOOL CustomStripifier::Exist(int faceId, int id1, int id2)
-{
-  /*	Does the edge specified by id1 and id2 exist in this
-	face currently? Maybe we deleted in partial triangulation
-  */
-  ListHead			*list_head;
-  PF_FACES			temp;
-  register int	x,size;
-  BOOL					a	=	FALSE;
-	BOOL					b =	FALSE;
-  
-  list_head	=	PolFaces[faceId];
-
-  temp	=	(PF_FACES) PeekList(list_head, LISTHEAD, 0);
-  size	=	temp->nPolSize;
-
-  for (x=0; x<size; x++)
-  {
-    if (*(temp->pPolygon+x) == id1)
-		{
-			a = TRUE;
-		}
-     
-		if (*(temp->pPolygon+x) == id2)
-		{
-			b = TRUE;
-		}
-
-    if (a && b)
-		{
-			return	TRUE;
-		}
-  }
-
-  return	FALSE;
-}
-
 ///	Different:
+//Return the vertex of the first triangle that is not in the second
 int CustomStripifier::Different(int id1,int id2,int id3,int id4,int id5, int id6, int *x, int *y)
 {
-  /*    Find the vertex in the first 3 numbers that does not exist in 
-	the last three numbers
-  */
   if ((id1 != id4) && (id1 != id5) && (id1 != id6))
     {
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshStripifier.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshStripifier.cpp	(revision 2341)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshStripifier.cpp	(revision 2549)
@@ -5966,66 +1232,28 @@
   id[index] = other2; index = !index;
   
-  a = temp4->face_id; 
-  b = temp5->face_id; 
-  c = temp6->face_id;
-  
-	/*
-  // If we need to rearrange the first sequence because otherwise there would have been a swap.
-  if ((temp3 != NULL) && (text) && ( vt[temp3->face_id]==0))
-    cptexture = FALSE;
-  if ((norm) && (!cptexture)) {
-    if (orient && startnewstrip) // If we want to keep orientation
-      preserve_strip_orientation_with_normal(output, vertex1+1,vn[vertex1]+1, other1+1,vn[other1]+1, other2+1,vn[other2]+1);
+  a = Strips[3]; 
+  b = Strips[4]; 
+  c = Strips[5];
+  
+  Orient(vertex1+1,other1+1,other2+1);
     
-    fprintf(output," %d//%d %d//%d %d//%d", vertex1+1,vn[vertex1]+1, other1+1,vn[other1]+1, other2+1,vn[other2]+1);
-  }
-  else if ((cptexture) && (!norm)) {
-    if (orient && startnewstrip) // If we want to keep orientation
-      preserve_strip_orientation_with_texture(output, vertex1+1,vt[vertex1]+1, other1+1,vt[other1]+1, other2+1,vt[other2]+1);
-    
-    fprintf(output," %d/%d %d/%d %d/%d", vertex1+1,vt[vertex1]+1, other1+1,vt[other1]+1, other2+1,vt[other2]+1);
-  }
-  else if ((cptexture) && (norm)) {
-    if (orient && startnewstrip) // If we want to keep orientation
-      preserve_strip_orientation_with_texture_and_normal(output, vertex1+1,vt[vertex1]+1,vn[vertex1]+1,
-							 other1+1,vt[other1]+1,vn[other1]+1, other2+1,vt[other2]+1,vn[other2]+1);
-    
-    fprintf(output," %d/%d/%d %d/%d/%d %d/%d/%d", vertex1+1,vt[vertex1]+1,vn[vertex1]+1,
-            other1+1,vt[other1]+1,vn[other1]+1, other2+1,vt[other2]+1,vn[other2]+1);
-  }
-  else
-  {
-	*/
-	if (orient && startnewstrip) // If we want to keep orientation
-		preserve_strip_orientation(vertex1+1,other1+1,other2+1);
-    
-//    fprintf(output," %d %d %d",vertex1+1,other1+1,other2+1);
-	mi_vector[num_tiras].push_back(vertex1);
-	mi_vector[num_tiras].push_back(other1);
-	mi_vector[num_tiras].push_back(other2);
-
-	/*
-  }
-  */
+  my_vector[num_tiras].push_back(vertex1);
+  my_vector[num_tiras].push_back(other1);
+  my_vector[num_tiras].push_back(other2);
+
   for (x = 6; x < num ; x = x+3)
   {
-	//    Get the next triangle
-    temp1 = ( P_STRIPS ) PeekList( pListHead, LISTHEAD, x);       
-    temp2 = ( P_STRIPS ) GetNextNode(temp1);                                      
-    temp3 = ( P_STRIPS ) GetNextNode(temp2);                                      
-      
     //    Error checking
-    if (!(member(id[0],a,b,c)) || !(member(id[1],a,b,c)) || !(member(vertex2,a,b,c)))
+	if (((id[0] != a) && (id[0] != b) && (id[0] != c)) ||
+		((id[1] != a) && (id[1] != b) && (id[1] != c)) ||
+		((vertex2 != a) && (vertex2 != b) && (vertex2 != c)))
     {
-		// If we used partial we might have a break in the middle of a strip
-//		fprintf(output,"\nt");
-        startnewstrip = 1;
-		mi_vector_tipo nada;
-		mi_vector.push_back(nada);
+		vector_int nada;
+		my_vector.push_back(nada);
+
 		num_tiras++;
-        // Find the vertex in the first triangle that is not in the second
-        vertex1 = Different(a,b,c,temp1->face_id,temp2->face_id,temp3->face_id,&other1,&other2);
-        // Find the vertex in the second triangle that is not in the first
-        vertex2 = Different(temp1->face_id,temp2->face_id,temp3->face_id, a,b,c,&other1,&other2);
+
+        vertex1 = Different(a,b,c,Strips[x],Strips[x+1],Strips[x+2],&other1,&other2);
+        vertex2 = Different(Strips[x],Strips[x+1],Strips[x+2], a,b,c,&other1,&other2);
 	  
         id[index] = vertex1; index = !index;
